package com.lianxin.pubqq.nearby;

import java.util.Set;

import com.lianxin.panqq.sms.MBluetoothDevice;
import com.lianxin.pubqq.R;

import android.app.Activity;
import android.bluetooth.BluetoothDevice;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.Window;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.Toast;

public class DevicesListActivity extends Activity {
    // Debugging
    private static final String TAG = "DevicesListActivity";
    private static final boolean D = true;
    private static boolean isDiscoveryIng = false;
    // Return Intent extra
    public static String EXTRA_DEVICE_ADDRESS = "device_address";

    // Member fields
    private ArrayAdapter<String> mPairedDevicesArrayAdapter;
    private ArrayAdapter<String> mNewDevicesArrayAdapter;
 // 本地蓝牙设备信息
 	private MBluetoothDevice mBluetoothDevice;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        // Setup the window
        requestWindowFeature(Window.FEATURE_INDETERMINATE_PROGRESS);
        setContentView(R.layout.bluetooth_device_list);

        // Set result CANCELED in case the user backs out
        setResult(Activity.RESULT_CANCELED);
        isDiscoveryIng = false;
      //打开蓝牙
        mBluetoothDevice = new MBluetoothDevice();       
        mBluetoothDevice.Init();
        if (!mBluetoothDevice.isPhoneDevice_Support()) {
            Toast.makeText(this, "本地手机不支持蓝牙服务！", Toast.LENGTH_LONG).show();

        } else if (!mBluetoothDevice.isBluetoothAdapter_Enable()){
            Toast.makeText(this, "请打开蓝牙！", Toast.LENGTH_LONG).show();
        } else {       	
            Toast.makeText(this, "蓝牙已成功打开", Toast.LENGTH_LONG).show();            
        }       
        // Initialize the button to perform device discovery
        final Button scanButton = (Button) findViewById(R.id.button_scan);
        scanButton.setOnClickListener(new OnClickListener() {
            public void onClick(View v) {
            	if(!isDiscoveryIng){
                    doDiscovery();
                    scanButton.setText("停止搜索"); 
                    isDiscoveryIng = true;                   
            	}else{
            		mBluetoothDevice.discoveryBluetooth_Cancel();
                    scanButton.setText("开始搜索"); 
                    isDiscoveryIng = false;           		
            	}
                //v.setVisibility(View.GONE);
            }
        });
    
        // Initialize array adapters. One for already paired devices and
        // one for newly discovered devices
        mPairedDevicesArrayAdapter = new ArrayAdapter<String>(this, R.layout.bluetooth_device_name);
        mNewDevicesArrayAdapter = new ArrayAdapter<String>(this, R.layout.bluetooth_device_name);

        // Find and set up the ListView for paired devices
        ListView pairedListView = (ListView) findViewById(R.id.paired_devices);
        pairedListView.setAdapter(mPairedDevicesArrayAdapter);
        pairedListView.setOnItemClickListener(mDeviceClickListener);

        // Find and set up the ListView for newly discovered devices
        ListView newDevicesListView = (ListView) findViewById(R.id.new_devices);
        newDevicesListView.setAdapter(mNewDevicesArrayAdapter);
        newDevicesListView.setOnItemClickListener(mDeviceClickListener);

        // Register for broadcasts when a device is discovered
        IntentFilter filter = new IntentFilter(BluetoothDevice.ACTION_FOUND);
        this.registerReceiver(mReceiver, filter);

        // Register for broadcasts when discovery has finished
       // mBluetoothDevice=new MBluetoothDevice();
        filter = new IntentFilter(mBluetoothDevice.Action_Bluetooth_Discovery_Finish);
        this.registerReceiver(mReceiver, filter);

        // Get a set of currently paired devices
        Set<BluetoothDevice> pairedDevices = mBluetoothDevice.getPairedDevices();

        // If there are paired devices, add each one to the ArrayAdapter
        if (pairedDevices.size() > 0) {
            findViewById(R.id.title_paired_devices).setVisibility(View.VISIBLE);
            for (BluetoothDevice device : pairedDevices) {
                mPairedDevicesArrayAdapter.add(device.getName() + "\n" + device.getAddress());
            }
        } else {
         //   String noDevices = getResources().getText(R.string.none_paired).toString();
            mPairedDevicesArrayAdapter.add("No devices have been paired");
        }
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();

        // Make sure we're not doing discovery anymore
        if (mBluetoothDevice.getBluetoothAdapter() != null) {
        	mBluetoothDevice.discoveryBluetooth_Cancel();
        }

        // Unregister broadcast listeners
        this.unregisterReceiver(mReceiver);
    }

    /**
     * Start device discover with the BluetoothAdapter
     */
    private void doDiscovery() {
        if (D) Log.d(TAG, "doDiscovery()");

        // Indicate scanning in the title
        setProgressBarIndeterminateVisibility(true);
      //  setTitle(R.string.scanning);
        setTitle("scanning for devices...");
        
        // Turn on sub-title for new devices
        findViewById(R.id.title_new_devices).setVisibility(View.VISIBLE);

        // If we're already discovering, stop it
        if (mBluetoothDevice.isBluetooth_discovering()) {
        	mBluetoothDevice.discoveryBluetooth_Cancel();
        }

        // Request discover from BluetoothAdapter
        mBluetoothDevice.discoveryBluetooth_Start();
    }

    // The on-click listener for all devices in the ListViews
    private OnItemClickListener mDeviceClickListener = new OnItemClickListener() {
        public void onItemClick(AdapterView<?> av, View v, int arg2, long arg3) {
            // Cancel discovery because it's costly and we're about to connect
        	mBluetoothDevice.discoveryBluetooth_Cancel();

            // Get the device MAC address, which is the last 17 chars in the View
            String info = ((TextView) v).getText().toString();
            String address = info.substring(info.length() - 17);

            // Create the result Intent and include the MAC address
            Intent intent = new Intent();
            intent.putExtra(EXTRA_DEVICE_ADDRESS, address);

            // Set result and finish this Activity
            setResult(Activity.RESULT_OK, intent);
            finish();
        }
    };

    // The BroadcastReceiver that listens for discovered devices and
    // changes the title when discovery is finished
    private final BroadcastReceiver mReceiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            String action = intent.getAction();

            // When discovery finds a device
            // 搜索发现设备时，取得设备的信息；注意，这里有可能重复搜索同一设备            
            if (BluetoothDevice.ACTION_FOUND.equals(action)) {
                // Get the BluetoothDevice object from the Intent
                BluetoothDevice device = intent.getParcelableExtra(BluetoothDevice.EXTRA_DEVICE);
                // If it's already paired, skip it, because it's been listed already
                if (device.getBondState() != BluetoothDevice.BOND_BONDED) {
                    mNewDevicesArrayAdapter.add(device.getName() + "\n" + device.getAddress());
                }
            // When discovery is finished, change the Activity title
            } else if (mBluetoothDevice.Action_Bluetooth_Discovery_Finish.equals(action)) {
                setProgressBarIndeterminateVisibility(false);
                setTitle("寻找连接设备");
                if (mNewDevicesArrayAdapter.getCount() == 0) {
                  //  String noDevices = getResources().getText(R.string.none_found).toString();
                    mNewDevicesArrayAdapter.add("No devices found");
                }
            }
            //状态改变时
         /*   else if (BluetoothDevice.ACTION_BOND_STATE_CHANGED.equals(action)) {
            	BluetoothDevice device = intent.getParcelableExtra(BluetoothDevice.EXTRA_DEVICE);
                switch (device.getBondState()) {
                    case BluetoothDevice.BOND_BONDING://正在配对
                        Log.d("BlueToothTestActivity", "正在配对......");
                        onRegisterBltReceiver.onBltIng(device);
                        break;
                    case BluetoothDevice.BOND_BONDED://配对结束
                        Log.d("BlueToothTestActivity", "完成配对");
                        onRegisterBltReceiver.onBltEnd(device);
                        break;
                    case BluetoothDevice.BOND_NONE://取消配对/未配对
                        Log.d("BlueToothTestActivity", "取消配对");
                        onRegisterBltReceiver.onBltNone(device);
                    default:
                        break;
                }
            }  */          
        }
    };

}